using Model;

namespace Services;

public interface ITeamService
{
    public Task<IEnumerable<Team>> ListTeamsOf(int userId);


    public Task<IEnumerable<Team>> ListTeams();
    public Task<int> CountTotalTeams();

    public Task<Team> AddTeam(string name, string picture, string firstColor, string secondColor);
    public Task RemoveTeams(params int[] teams);

    public IEnumerable<Member> GetMembersOf(int teamId);

    public Task<Member> AddMember(int teamId, int userId, MemberRole role);
    
    public Task<bool> UpdateMember(Member member);

    public Task<bool> RemoveMember(int teamId, int userId);

    public Task<bool> UpdateTeam(Team team);
    
    public Task<IEnumerable<Tactic>> GetSharedTacticsToTeam(int teamId);

    public Task<bool> IsUserInTeam(int userId, int teamId);

}