﻿using Model;

namespace Services;

public interface IUserService
{

    Task<int> UsersCount(string nameNeedle);
    Task<int> UsersCount();
    
    Task<IEnumerable<User>> ListUsers(string nameNeedle);
    Task<IEnumerable<User>> ListUsers();

    Task<User?> GetUser(int id);
    Task<User?> GetUser(string email);

    Task<User> CreateUser(string username, string email, string password, string profilePicture, bool isAdmin);

    Task<bool> RemoveUsers(params int[] identifiers);

    Task UpdateUser(User user);
    
    public Task<User?> Authorize(string email, string password);
    
    public Task<IEnumerable<Tactic>> GetSharedTacticsToUser(int userId);


}